Baresip4RENAvisio
-----------------

A simple, portable, cross-platform, SIP client for RENAvisio...

Binaries
--------

Build Environment
-----------
Tested with:
 - Ubuntu 16.04.1, x86_64, Kernel 4.13.0-37-generic   
 - Debian 9.7, x86_64, Kernel 4.9.0-8-amd64   

Prerequisites: git, svn, wget, "build-essential", autoconf...


Build
----- 


Third Party Libraries :

	###### ssl, sdl2, v4l2, alsa, spandsp ######
		sudo apt-get install libssl-dev libsdl2-dev libv4l-dev libasound2-dev libspandsp-dev
	###### nasm ######
		wget http://www.nasm.us/pub/nasm/releasebuilds/2.13.02/nasm-2.13.02.tar.bz2 .
		tar xjvf nasm-2.13.02.tar.bz2
		cd nasm-2.13.02 
		export NASM_PATH=`pwd`
		./autogen.sh 
		./configure && make
		cd ..
	###### x264 ######
		git clone http://git.videolan.org/git/x264.git
		cd x264
		export X264_PATH=`pwd`
		PATH="$NASM_PATH:$PATH" ./configure  --disable-swscale --prefix=$X264_PATH/build --enable-shared && make install
		make && make install
		cd ..
	###### FFmpeg ######
		wget https://www.ffmpeg.org/releases/ffmpeg-4.1.1.tar.gz
		tar -xzf ffmpeg-4.1.1.tar.gz
		cd ffmpeg-4.1.1 
		export FFMPEG_PATH=`pwd`
		mkdir build
		PKG_CONFIG_PATH=$X264_PATH/build/lib/pkgconfig ./configure --enable-shared --disable-programs --disable-doc --disable-v4l2-m2m  --prefix=$FFMPEG_PATH/build  --extra-ldflags="-Wl,-rpath,\$$ORIGIN/,-rpath,\$$ORIGIN/lib" --enable-libx264 --enable-gpl
		make && make install
		cd ..
		
		


Baresip project:   

	git clone https://github.com/creytiv/re.git && cd re
	make PREFIX=baresip_install  DESTDIR=../ install
	cd ..
	git clone https://github.com/creytiv/rem.git && cd rem/
	make PREFIX=baresip_install  DESTDIR=../ install
	cd ..
	git clone https://github.com/alfredh/baresip.git && cd baresip
	CFLAGS="-I$FFMPEG_PATH -I$X264_PATH" LIBS='-Wl,-rpath,\$$ORIGIN/../lib' MOD_LFLAGS="-L$FFMPEG_PATH/build/lib -L$X264_PATH/build/lib '-Wl,-rpath,\$$ORIGIN/lib'" make USE_AVCODEC=1 USE_AVFORMAT=1  USE_X11GRAB=1 USE_X264=1 USE_G722=1  PREFIX=baresip_install  DESTDIR=../ install
	cd ..



Configuration:   

	cp $X264_PATH/libx264.so.* baresip_install/lib
	ls $FFMPEG_PATH/build/lib/*.so.*.*.* | awk -F'.' '{print $1"."$2"."$3"."$4"."$5}' | xargs -i -t cp {} baresip_install/lib
	cd baresip_install
	./bin/baresip -f .baresip -t
	sed -i 's|.*module_path.*|module_path\t\t./lib/baresip/modules|' .baresip/config
	sed -i 's|.*audio_path.*|audio_path\t\t./share/baresip|' .baresip/config
	sed -i 's|.*video_fullscreen.*|video_fullscreen\t\tno|' .baresip/config
	sed -i 's/.*sdl2.so.*/module\t\tsdl2.so/' .baresip/config
	sed -i 's/.*v4l.so.*/module\t\tv4l2.so/' .baresip/config
	sed -i 's/.*httpd.so.*/module\t\thttpd.so/' .baresip/config
	sed -i 's/.*g722.so.*/module\t\tg722.so/' .baresip/config
	sed -i 's/.*alsa.so.*/#module\t\talsa.so/' .baresip/config
	sed -i 's/.*pulse.so.*/module\t\tpulse.so/' .baresip/config
	./bin/baresip -f .baresip 
	q
	sed -i 's/ <sip.*//' .baresip/accounts
	sed -i '/<sip:/s/^#//g' .baresip/accounts


Usage
----- 

	(sleep 2; xdg-open webui/baresip4renavisio.html) & LD_LIBRARY_PATH=`pwd`/lib ./bin/baresip -f ./.baresip




